using System;
using System.Text;
using System.Linq;
using System.Collections.Generic;

/// @author Antti-Jussi
/// @version 04.02.2025
///
/// <summary>
/// Testauksen harjoittelua
/// </summary>
public class Testaaminen
{
    /// <summary>
    /// Eri testaustapoja.
    /// </summary>
    public static void Main()
    {
        // Esimerkki 1: Summa-funktion tulostustestaus
        // Ts. katsotaan "silmämäärisesti" näyttääkö tulos oikealta
        Console.WriteLine(Summa(1, 3)); // tästä pitäisi tulla 4
        Console.WriteLine(Summa(0, -1));

        // Esimerkki 2: Summa-funktion tuloksen vertailu odotettuun Mainissa
        // Jos testi "feilaa" (epäonnistuu, siis tulos on False), niin joko testissä TAI funktion toteutuksessa on vikaa
        Console.WriteLine(4 == Summa(1, 3)); 
        Console.WriteLine(-1 == Summa(0, -1));
        Console.WriteLine(int.MinValue == Summa(int.MaxValue, 1));

        // Esimerkki 3: Summa-funktion yksikkötestit Comtestin avulla
        
        // Esimerkki 4: Jaa kolmella (double-lukujen vertaaminen toisiinsa testauksen yhteydessä.)
        double jaettu = JaaKolmella(3.0);
        Console.WriteLine(jaettu);

        // Esimerkki 5: Kolmion ala
        double kolmionAla = KolmionAla(5.0, 8.5);
        Console.WriteLine(kolmionAla);
        // Jos funktiota kutsuttaisiin ns. mielettömällä syötteellä,
        // funktion pitäisi silti toimia. Jätetään tämä kuitenkin omatoimiseksi harjoitustehtäväksi. 
        // if (kolmionAla >= 0) // OK
        // else // alan lasku meni pieleen
        
        // Esimerkki 6: Monista merkki
        string jono = Monista('A');
        Console.WriteLine(jono);
    }

    /// <summary>
    /// Monistaa annetun merkin kolmen
    /// merkin mittaiseksi merkkijonoksi.
    /// </summary>
    /// <param name="merkki">Monistettava merkki.</param>
    /// <returns>Monistetuista merkeistä koostuva jono.</returns>
    /// <example>
    /// <pre name="test">
    /// Monista('A') === "AAA";
    /// Monista('a') === "aaa";
    /// Monista(' ') === "   ";
    /// Monista('b') === "bbb";
    /// // Tyhjää merkkiä ei voi monistaa. Tämä aiheuttaisi käännösvirheen. 
    /// // Monista('')  === "";
    /// </pre>
    /// </example>
    public static string Monista(char merkki)
    {
        // Käytetään muotoilujonoa (eli dollarimerkillä alkavaa merkkijonoa)
        // jonka sisään sijoitetaan muuttujan merkki sisältö kolmasi
        string jono = $"{merkki}{merkki}{merkki}";
        return jono;
    }
    
    /// <summary>
    /// Kolmion pinta-ala
    /// </summary>
    /// <param name="kanta">Kanta</param>
    /// <param name="korkeus">Korkeus</param>
    /// <returns>Kolmion ala</returns>
    /// <example>
    /// <pre name="test">
    /// KolmionAla(5, 8) ~~~ 20.0;
    /// KolmionAla(7, 3) ~~~ 10.5;
    /// KolmionAla(7.5, 3.5) ~~~ 13.125;
    /// KolmionAla(0.0, 0.0) ~~~ 0.0;
    /// KolmionAla(-1.0, 1.0) ~~~ -0.5;
    /// </pre>
    /// </example>
    public static double KolmionAla(double kanta, double korkeus)
    {
        // if (kanta < 0) return -1;
        double ala = kanta * korkeus / 2;
        return ala;
    }

    /// <summary>
    /// Jaa annettu jaettava kolmella. 
    /// </summary>
    /// <param name="jaettava">Luku</param>
    /// <returns>Luku jaettuna kolmella</returns>
    /// <example>
    /// <pre name="test">
    /// JaaKolmella(3.0) ~~~ 1.0;
    /// JaaKolmella(10.0) ~~~ 3.333333;
    /// JaaKolmella(0.3) ~~~ 0.1;
    /// // Liukulukuja ei _yleensä_ pidä verrata toisiinsa
    /// // kahdella on-yhtäsuurta-merkillä. 
    /// JaaKolmella(1.0) ~~~ 0.3333333;
    /// </pre>
    /// </example>
    public static double JaaKolmella(double jaettava)
    {
        return jaettava / 3.0;
    }

    /// <summary>
    /// Kahden luvun summa
    /// </summary>
    /// <param name="a">Luku 1</param>
    /// <param name="b">Luku 2</param>
    /// <returns>Summa</returns>
    /// <example>
    /// <pre name="test">
    /// Summa(1, 3) === 4;
    /// Summa(1, 4) === 5;
    /// Summa(-1, 1) === 0;
    /// Summa(0, 5) === 5;
    /// </pre>
    /// </example>
    public static int Summa(int a, int b)
    {
        return a + b;
    }
}